// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package v1

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// RestoreServiceClient is the client API for RestoreService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type RestoreServiceClient interface {
	CreateRestore(ctx context.Context, in *CreateRestoreRequest, opts ...grpc.CallOption) (*CreateRestoreResponse, error)
	GetRestoreById(ctx context.Context, in *GetRestoreByIdRequest, opts ...grpc.CallOption) (*GetRestoreByIdResponse, error)
	GetRestores(ctx context.Context, in *GetRestoresRequest, opts ...grpc.CallOption) (*GetRestoresResponse, error)
}

type restoreServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewRestoreServiceClient(cc grpc.ClientConnInterface) RestoreServiceClient {
	return &restoreServiceClient{cc}
}

func (c *restoreServiceClient) CreateRestore(ctx context.Context, in *CreateRestoreRequest, opts ...grpc.CallOption) (*CreateRestoreResponse, error) {
	out := new(CreateRestoreResponse)
	err := c.cc.Invoke(ctx, "/api.infranetes.user.v1.RestoreService/CreateRestore", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *restoreServiceClient) GetRestoreById(ctx context.Context, in *GetRestoreByIdRequest, opts ...grpc.CallOption) (*GetRestoreByIdResponse, error) {
	out := new(GetRestoreByIdResponse)
	err := c.cc.Invoke(ctx, "/api.infranetes.user.v1.RestoreService/GetRestoreById", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *restoreServiceClient) GetRestores(ctx context.Context, in *GetRestoresRequest, opts ...grpc.CallOption) (*GetRestoresResponse, error) {
	out := new(GetRestoresResponse)
	err := c.cc.Invoke(ctx, "/api.infranetes.user.v1.RestoreService/GetRestores", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// RestoreServiceServer is the server API for RestoreService service.
// All implementations should embed UnimplementedRestoreServiceServer
// for forward compatibility
type RestoreServiceServer interface {
	CreateRestore(context.Context, *CreateRestoreRequest) (*CreateRestoreResponse, error)
	GetRestoreById(context.Context, *GetRestoreByIdRequest) (*GetRestoreByIdResponse, error)
	GetRestores(context.Context, *GetRestoresRequest) (*GetRestoresResponse, error)
}

// UnimplementedRestoreServiceServer should be embedded to have forward compatible implementations.
type UnimplementedRestoreServiceServer struct {
}

func (UnimplementedRestoreServiceServer) CreateRestore(context.Context, *CreateRestoreRequest) (*CreateRestoreResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateRestore not implemented")
}
func (UnimplementedRestoreServiceServer) GetRestoreById(context.Context, *GetRestoreByIdRequest) (*GetRestoreByIdResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetRestoreById not implemented")
}
func (UnimplementedRestoreServiceServer) GetRestores(context.Context, *GetRestoresRequest) (*GetRestoresResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetRestores not implemented")
}

// UnsafeRestoreServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to RestoreServiceServer will
// result in compilation errors.
type UnsafeRestoreServiceServer interface {
	mustEmbedUnimplementedRestoreServiceServer()
}

func RegisterRestoreServiceServer(s grpc.ServiceRegistrar, srv RestoreServiceServer) {
	s.RegisterService(&RestoreService_ServiceDesc, srv)
}

func _RestoreService_CreateRestore_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateRestoreRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(RestoreServiceServer).CreateRestore(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/api.infranetes.user.v1.RestoreService/CreateRestore",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(RestoreServiceServer).CreateRestore(ctx, req.(*CreateRestoreRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _RestoreService_GetRestoreById_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetRestoreByIdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(RestoreServiceServer).GetRestoreById(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/api.infranetes.user.v1.RestoreService/GetRestoreById",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(RestoreServiceServer).GetRestoreById(ctx, req.(*GetRestoreByIdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _RestoreService_GetRestores_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetRestoresRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(RestoreServiceServer).GetRestores(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/api.infranetes.user.v1.RestoreService/GetRestores",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(RestoreServiceServer).GetRestores(ctx, req.(*GetRestoresRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// RestoreService_ServiceDesc is the grpc.ServiceDesc for RestoreService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var RestoreService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "api.infranetes.user.v1.RestoreService",
	HandlerType: (*RestoreServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CreateRestore",
			Handler:    _RestoreService_CreateRestore_Handler,
		},
		{
			MethodName: "GetRestoreById",
			Handler:    _RestoreService_GetRestoreById_Handler,
		},
		{
			MethodName: "GetRestores",
			Handler:    _RestoreService_GetRestores_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "infranetes/user/v1/restore.proto",
}
